#!/bin/sh
#
# Copyright (c) Semarchy.  All rights reserved.
#
# PRODUCT Semarchy xDI Runtime
#   
#	This script allows to start a Runtime.
#
#	The Runtime will be started using the default configuration files and VM properties if no parameters are specified.
#	You can have a look at the initvariables.sh script to find these default properties if required.
#
#	Note:
#	To have an overview of the possible parameters, use the -usage parameter
#	
#	Examples:
#	startengine.sh -usage
#	startengine.sh -port 42000
#


if [ "$XDI_RUNTIME_HOME" = "" ]; then
        XDI_RUNTIME_HOME=.
        export XDI_RUNTIME_HOME
fi

. $XDI_RUNTIME_HOME/initvariables.sh


if [ "$STAMBIA_JAVA_HOME" = "" ]; then
        if [ "$JAVA_HOME" = "" ]; then
	        java -debug $XDI_RUNTIME_VM_PROPERTIES $XDI_RUNTIME_STARTENGINE_VM_PROPERTIES -Xms$XDI_RUNTIME_INIT_MEMORY -Xmx$XDI_RUNTIME_MAX_MEMORY -Xss$XDI_RUNTIME_STACK_SIZE $XDI_RUNTIME_SYSTEM_CLASSLOADER -classpath "$XDI_RUNTIME_CLASSPATH" $SCHEDULE_PROPS $SECURITY_PROPS com.indy.engine.launcher.MainLauncher -mainclass com.indy.engine.EngineStartI   -conf $XDI_RUNTIME_CONF_FILE_LOCATION "$@"
        else
                "$JAVA_HOME/bin/java"  $XDI_RUNTIME_VM_PROPERTIES $XDI_RUNTIME_STARTENGINE_VM_PROPERTIES -Xms$XDI_RUNTIME_INIT_MEMORY -Xmx$XDI_RUNTIME_MAX_MEMORY -Xss$XDI_RUNTIME_STACK_SIZE $XDI_RUNTIME_SYSTEM_CLASSLOADER -classpath "$XDI_RUNTIME_CLASSPATH" $SCHEDULE_PROPS $SECURITY_PROPS com.indy.engine.launcher.MainLauncher -mainclass com.indy.engine.EngineStartI  -conf $XDI_RUNTIME_CONF_FILE_LOCATION "$@"
        fi
else
	"$STAMBIA_JAVA_HOME/bin/java"  $XDI_RUNTIME_VM_PROPERTIES $XDI_RUNTIME_STARTENGINE_VM_PROPERTIES -Xms$XDI_RUNTIME_INIT_MEMORY -Xmx$XDI_RUNTIME_MAX_MEMORY -Xss$XDI_RUNTIME_STACK_SIZE $XDI_RUNTIME_SYSTEM_CLASSLOADER -classpath "$XDI_RUNTIME_CLASSPATH" $SCHEDULE_PROPS $SECURITY_PROPS com.indy.engine.launcher.MainLauncher -mainclass com.indy.engine.EngineStartI  -conf $XDI_RUNTIME_CONF_FILE_LOCATION "$@"
fi
